.. fir_filter_scaled_design

.. This file is protected by Copyright. Please refer to the COPYRIGHT file
   distributed with this source distribution.

   This file is part of OpenCPI <http://www.opencpi.org>

   OpenCPI is free software: you can redistribute it and/or modify it under the
   terms of the GNU Lesser General Public License as published by the Free
   Software Foundation, either version 3 of the License, or (at your option) any
   later version.

   OpenCPI is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
   A PARTICULAR PURPOSE. See the GNU Lesser General Public License for
   more details.

   You should have received a copy of the GNU Lesser General Public License
   along with this program. If not, see <http://www.gnu.org/licenses/>.

Implements a FIR filter and then right shifts the output by a set amount. This right shift allows the gain of the filter to be compensated for by any power-of-2. A final rounding stage rounds the result to an integer.

The mathematical representation of the implementation is given in :eq:`|component_name|-fir-filter-scaled-equation`.

.. math::
   :label: |component_name|-fir-filter-scaled-equation

   y[n] = \frac {\sum_{k=0}^{N-1} h[k] x[n-i]}{2^{F_s}}

In :eq:`|component_name|-fir-filter-scaled-equation`:

 * :math:`x[n]` is the input values.

 * :math:`y[n]` is the output values.

 * :math:`N` is the total number of taps.

 * :math:`h[k]` is the taps values, where there are :math:`N` taps index from :math:`0` to :math:`N - 1`.

 * :math:`F_s` is the value of the output scale factor.

A generic block diagram representation of the implementation is given in :numref:`|component_name|-fir-filter-scaled-diagram`. Implementation within the HDL is configuration dependent, and described within the HDL worker documentation.

.. _|component_name|-fir-filter-scaled-diagram:

.. figure:: |include_dir|fir_filter_scaled.svg
   :alt: Block diagram outlining finite impulse response (FIR) filter (scaled) implementation.
   :align: center

   Block diagram outlining finite impulse response (FIR) filter (scaled) implementation.

As the calculation involves rounding, there is a choice of rounding types that can be selected via the ``rounding_type`` property. The application should choose between half-up, half-even or truncation to minimise any bias. The truncation also has a choice to saturate the output generated by the component to the maximum or minimum value defined by the output type (e.g. -32,768 to 32,767 for short values). This can be achieved by using the ``truncate_with_saturation`` value.
